#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "Dictionary.h"
#include "Hash.h"
#include "Game.h"

Game::Game(char *word)
{

    score = 0;
    letters = 0;
    strncpy( nineword, word, 10 );
    hash = new Hash(101);

}


#define ITERATIONS 3
/* strfry() is a GNU-ism, so I have to make my own shuffler */
char *Game::shuffle(void)
{
     char *str, c;
     int i, j, k;
     int length;
     
     str = (char *)strdup(nineword);
     length = strlen(str);

     for( i=0 ; i<ITERATIONS ; i++ ) {
	  for( j=0 ; j<length ; j++ ) {
	       k = random()%length;
	       // Swap str[j] & str[k]
	       c = str[j];
	       str[j] = str[k];
	       str[k] = c;
	  }
	  //printf("Shuffled string = %s\n", str);
     }

     /* Middle letter is used to see if word islegit below */
     this->middle_letter = str[4];

     return str;

}

/* Check to see if word is legit */
bool Game::islegit(char *word)
{
    int i, j, len;
    bool letter[9], found;

    len = strlen(word);

    if( len < 4 ) {
	//printf("Too short\n");
	return false;
    }

    /* Check to see if it contains any letter that's not in the
       original string (will only happen with text entry) */
    for( i=0 ; i<9 ; i++ )
	letter[i] = false;

    for( i=0 ; i<len ; i++ ) {
	found = false;
	for( j=0 ; j<9 ; j++ )
	    if( word[i] == nineword[j] && !letter[j] ) {
		letter[j] = true; //this letter is now vouched for
		found = true;
		break;
	    }
	if( !found ) {
	    //printf("a free %c not found\n", word[i]);
	    return false; //not found
	}
    }

    for( i=0 ; i<len ; i++ ) {
	if( word[i] == middle_letter )
	    return true;
    }

    return false;

}


extern Dictionary *dict;

/* Returns true if check passed */
bool Game::check(char *word)
{

    if( islegit(word) )
	if( dict->isaword(word) ) {
	    if( hash->lookup(word) )
		return false; // Already found this word
	    else if( hash->install(word) == NULL ) {
		printf("Error installing %s on hashtable\n", word);
		exit(1);
	    } else {
		score++;
		letters += strlen(word);
		return true;
	    }
	}

    // FIXME: Add a check to see if it's an actual word,
    // just not in the dictionary??
     
    return false;

}
