#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>

#include "Nineword.h"
#include "Wordlist.h"

/* Attatch a wordlist to parent */
Wordlist::Wordlist(GtkWidget *parent)
{

    /*  Scrolled window and list for keeping track of what we've found */
    GtkWidget *scrolledwin = gtk_scrolled_window_new (NULL, NULL);
    gtk_scrolled_window_set_policy( GTK_SCROLLED_WINDOW(scrolledwin),
				    GTK_POLICY_AUTOMATIC,
				    GTK_POLICY_AUTOMATIC);
    
    gtk_widget_set_usize( scrolledwin, 10, 160 );
    gtk_box_pack_start( GTK_BOX(parent), scrolledwin, TRUE, TRUE, 10 );
    gtk_widget_show( scrolledwin );
    
    char *titles[2] = { "Word", "Letters" };
    clist = gtk_clist_new_with_titles( 2, titles );
    gtk_clist_set_column_width( GTK_CLIST(clist), 0, 160 );
    gtk_container_add( GTK_CONTAINER(scrolledwin), clist );
    gtk_widget_show( clist );
    
}


void Wordlist::add(char *word)
{
    char *str[2];
    char digit[LETTSIZE];

    str[0] = word;
    str[1] = digit;

    snprintf(digit, LETTSIZE, "%d", strlen(word));
    gtk_clist_append( (GtkCList *)clist, str);

}


void Wordlist::clear(void)
{

    gtk_clist_clear(GTK_CLIST(clist));

}
